<template>
  <div
    v-if="product.name"
    class="page-detail"
    itemtype="http://schema.org/Product"
    itemscope
  >
    <Breadcrumb :breadcrumb="breadCrumb" />
    <section class="content-middle productdetail clearfix">
      <div class="border-bottom flex">
        <ProductDetailThumb
          :product="product"
          :ratetotal="rate_total"
          :rateaverage="rate_average"
          :meta="meta"
        />
        <ProductDetailInfo
          :product="product"
          :get-product="(slug, sku) => getProduct(slug, sku)"
          :ratetotal="rate_total"
          :rateaverage="rate_average"
          :meta="meta"
        />
      </div>
    </section>
    <ProductDetailContent
      :product="product"
      :comments="comments"
      :meta="meta"
      :links="links"
      :add-comment="(content, parent_id) => addComment(content, parent_id)"
      :get-comments="(link) => getComments(link)"
      :rates="rates"
      :rate_meta="rate_meta"
      :rate_links="rate_links"
      :rate_total="rate_total"
      :rate_average="rate_average"
      :get-rates="(link) => getRates(link)"
      :add-rate="(content, stars) => addRate(content, stars)"
    />
    <ProductDetailSticky :product="product" />
  </div>
</template>

<script>
export default {
  name: 'ProductDetail',
  components: {
    Breadcrumb: () => import('~/components/Breadcrumb'),
    ProductDetailThumb: () =>
      import('~/components/Products/Detail/ProductDetailThumb'),
    ProductDetailInfo: () =>
      import('~/components/Products/Detail/ProductDetailInfo'),
    ProductDetailSticky: () =>
      import('~/components/Products/Detail/ProductDetailSticky'),
    ProductDetailContent: () =>
      import('~/components/Products/Detail/ProductDetailContent'),
  },
  async asyncData({ params, $axios, query, error }) {
    try {
      const slug = params.productSlug
      const sku = query.option
      const product = await $axios.$get(
        '/product/detail/' + slug + '?option=' + sku
      )
      const comments = await $axios.$get('/product/comments/' + slug)
      const rates = await $axios.$get('/product/rates/' + slug)
      const metaseo = await $axios.$get('/product/seo/' + slug)
      return {
        product: product.data,
        breadCrumb: [{ name: 'Laptop', url: '/may-tinh-xach-tay' }],
        comments: comments.data,
        rates: rates.data,
        meta: comments.meta,
        links: comments.links,
        rate_meta: rates.meta,
        rate_links: rates.links,
        rate_total: rates.total,
        rate_average: rates.average,
        metaseo: metaseo.data,
      }
    } catch {
      error({
        statusCode: 404,
        message: 'No products found',
      })
    }
  },
  mounted() {
    if (this.$auth.loggedIn) {
      this.seenProduct()
    }
  },
  methods: {
    async seenProduct() {
      try {
        await this.$axios.$get('/home/products/seen/' + this.product.id)
      } catch (e) {}
    },
    async getComments(link) {
      const comments = await this.$axios.$get(link)
      this.comments = [...this.comments, ...comments.data]
      this.links = comments.links
    },
    async getRates(link) {
      const rates = await this.$axios.$get(link)
      this.rates = [...this.rates, ...rates.data]
      this.rate_links = rates.links
    },
    async addComment(content, parent_id = null) {
      const slug = this.$route.params.productSlug
      const data = {
        product_shared_url: slug,
        content,
        parent_id,
      }
      const newComment = {
        content: data.content,
        created_user: this.$auth.user,
        created_at: 'Bây giờ',
      }
      // eslint-disable-next-line camelcase
      if (parent_id) {
        // eslint-disable-next-line camelcase
        const parent = this.comments.find((pr) => pr.id === parent_id)
        parent.children = [...parent.children, newComment]
      } else {
        this.comments = [newComment, ...this.comments]
      }
      await this.$axios.$post('/product/comment/add', data)
    },
    addRate(content, stars) {
      const newRate = {
        content,
        stars,
        created_user: this.$auth.user,
        created_at: 'Bây giờ',
      }
      this.rates = [newRate, ...this.rates]
    },
    async getProduct(slug, sku) {
      if (sku !== null) {
        const product = await this.$axios.$get(
          '/product/detail/' + slug + '?option=' + sku
        )
        this.product = product.data
      } else {
        const product = await this.$axios.$get('/product/detail/' + slug)
        this.product = product.data
      }
    },
  },
  head() {
    return {
      title: this.metaseo.title
        ? this.metaseo.title
        : this.product.name + ' | Thinkpro',
      meta: [
        {
          hid: 'description',
          name: 'description',
          content: this.metaseo.description,
        },
        {
          hid: 'keywords',
          name: 'keywords',
          content: this.metaseo.keywords ? this.metaseo.keywords.slice() : '',
        },
        {
          hid: 'og:type',
          name: 'og:type',
          content: 'website',
        },
        {
          hid: 'og:site_name',
          name: 'og:site_name',
          content: 'Thinkpro',
        },
        {
          hid: 'og:image',
          name: 'og:image',
          content: 'https://admin.thinkpro.vn/' + this.product.thumbnail,
        },
        {
          hid: 'og:url',
          name: 'og:url',
          content: 'https://thinkpro.vn/' + this.product.shared_url,
        },
        {
          hid: 'og:title',
          name: 'og:title',
          content: this.metaseo.title
            ? this.metaseo.title
            : this.product.name + ' | Thinkpro',
        },
        {
          hid: 'og:description',
          name: 'og:description',
          content: this.metaseo.description,
        },
      ],
    }
  },
}
</script>
<style lang="scss" src="~/assets/css/product.scss"></style>
<style lang="scss" src="~/assets/css/comment.scss"></style>
